//+------------------------------------------------------------------+
//|                                                  NeuroExpert.mq4 |
//|                                          Copyright  2007, Klot. |
//|                                            http://www.fxreal.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Klot."
#property link      "http://www.fxreal.ru/"
#define pi 3.14159265358979323846
//---
#include <dtTradeLib.mqh>
//---
extern double th=0.5;
//---
extern int T1=6;
extern int T2=33;
extern int T3=56;
extern int T4=17;
//---
extern double w1=0.5;
extern double w2=0.7;
extern double w3=-0.7;
extern double w4=-0.4;
extern double w5=0;
extern double w6=0.9;
extern double w7=-1;
extern double w8=-0.5;
extern double w9=0.3;
extern double w10=-0.3;
extern double w11=0.7;
extern double w12=-0.6;
extern double w13=1;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double LinRegresSlope(string sym, int length, int shift)
{
   int m_pos[2];
   m_pos[0]=shift;
   m_pos[1]=shift+length;
   int n=m_pos[1]-m_pos[0]+1;
//---- calculate price values
   double value=iClose(sym,0,m_pos[0]);
   double a,b,c;
   double sumy=value;
   double sumx=0.0;
   double sumxy=0.0;
   double sumx2=0.0;
   for(int i=1; i<n; i++)
     {
      value=iClose(sym,0,m_pos[0]+i);
      sumy+=value;
      sumxy+=value*i;
      sumx+=i;
      sumx2+=i*i;
     }
   c=sumx2*n-sumx*sumx;
   if(c==0.0) c=0.000001;
   b=(sumxy*n-sumx*sumy)/c;
   a=(sumy-sumx*b)/n;
   //m_value[0]=a;
   //m_value[Extlength]=a+b*n;
   return(MathArctan(1000*(a -(a+b*n))/n));
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   //----
   double fx[4],ww[13];
   double ret1,ma,dev;
   //---
   if( !f_New_Bar(0) ) return(0);
   //---
   fx[0]=LinRegresSlope("EURUSD",T1,1);
   fx[1]=LinRegresSlope("USDCHF",T2,1);
   fx[2]=LinRegresSlope("EURCHF",T3,1);
   fx[3]=LinRegresSlope("EURGBP",T4,1);
   //--- -----
   double rmax=fx[ArrayMaximum(fx)];
   double rmin=fx[ArrayMinimum(fx)];
   double range=(rmax-rmin);
   if( range==0 ) { Print ("InNormalize:  range=0"); return; }
   for(int i=0;i<4;i++) fx[i]=2.0*(fx[i]-rmin)/range-1.0;
   //---------------------------
   ww[0]=w1;
   ww[1]=w2;
   ww[2]=w3;
   ww[3]=w4;
   ww[4]=w5;
   ww[5]=w6;
   ww[6]=w7;
   ww[7]=w8;
   ww[8]=w9;
   ww[9]=w10;
   ww[10]=w11;
   ww[11]=w12;
   ww[12]=w13;
   //---
   ret1=neuronet1(ww,fx);
   //---
   Comment("ret1 = ",ret1,"  ma = ",ma,"  dev = ",dev, "\n",
           "fx1 = ",fx[0],"  fx2 = ",fx[1],"  fx3 = ",fx[2],"  fx4 = ",fx[3]);
   //---
   int pos[2]={0,0};
   //---
   Check_for_open_poz(pos);
   //---
   if( ret1<-th && pos[0]!= -1 ) {  close_order(1); sell_open(0,0); }
   if( ret1>th && pos[1]!= 1 ) {  close_order(-1); buy_open(0,0); }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| 2-    3-  |
//|   -   |
//|   -   |
//|  W[0], W[N+1], W[2*N+2] -    |
//| N -   |
//|      N*2+2+3 |
//+------------------------------------------------------------------+
double neuronet1(double W[],double x[]) 
{
int i;
int N=ArraySize(x);
//---
if(ArraySize(W)!=N*2+5) {
   Print("!      = ",N*2+5);
   return(0);
}
//---
double sum=0.0;
double Out1=0.0, Out2=0.0;
//---Neuron 1 ----------------+
sum=W[0];
//---
for(i=1; i<=N; i++) { 
   sum+=W[i]*x[i-1];
}
Out1=th(sum);
//---Neuron 2 ----------------+
sum=W[N+1];
//---
for(i=N+2; i<=2*N+1; i++) { 
   sum+=W[i]*x[i-N-2];
}
Out2=th(sum);
//---Neuron 3 ----------------+
return(th(Out1*W[2*N+3]+Out2*W[2*N+4]+W[2*N+2]));
}
//+-----------------------------------------------------------------+
//|   |
//+-----------------------------------------------------------------+
double th(double x)
{
double x_=MathExp(x);
double _x=MathExp(-x);
//-----
double a=(x_+_x);
double b=(x_-_x);
if( a==0) a=0.00000001;
return(b/a);
}
//+-----------------------------------------------------------------+
//+------------------------------------------------------------------+
//| expert fourier function                                          |
//+------------------------------------------------------------------+
bool f_New_Bar(int timeframe)                        
{                                           
      static datetime New_Time=0;
      bool New_Bar = false;
      if (New_Time != iTime(Symbol(),timeframe,0) )  {
         New_Time = iTime(Symbol(),timeframe,0);
         New_Bar = true;
      }
   return(New_Bar);
}

